%Erg_speichern

%Shaker-Regelung mit Sinus are free software.
%you can redistribute it and/or under terms of the GNU General Public
%License as published by the Free Software Foundation.
%Shaker-Regelung mit Sinus are distributed in the hope that will useful,
%but without any warranty, without even the implied warranty of
%merchantability or fitness for a particular purpose. See the GNU for more
%details:
%Florian Fltzinger
%Hochschule fr angewandte Wissenschaften Mnchen
%University of applied sciences Munich

%Diese Funktion dient alleine zum Speichern der Messergebnisse in einer
%Struktur. Sie wird vom Messlistener aufgerufen, sobald das
%Regelendekriterium erreicht ist. Sie gibt die gespeicherten Messwerte an
%den Messlistener zurck, der die Struktur nun global an das Hauptskript
%"main" weitergibt.

function [ Messwerte ] = Erg_speichern( )

global  f V df fmax  GE Ergebnis fs m b w F ;

Messwerte = struct;
    Name='Versuch';
    Messwerte.(Name)='Versuchsnummer';
    Messwerte.fs = fs;
    Messwerte.Messpunkte(2).Groesse='Beschleunigung';
    Messwerte.Messpunkte(2).Sensor='Isotron 7251A-100 SN12342';
    Messwerte.Messpunkte(2).EU='m/s';
    Messwerte.Messpunkte(2).Kalibrierwert=10.48;
    Messwerte.Messpunkte(2).Kalibrierwert_unit='mV/m/s';
    Messwerte.Messpunkte(2).Koord_x=0;
    Messwerte.Messpunkte(2).Koord_y=0;
    Messwerte.Messpunkte(2).Koord_z=0;
    Messwerte.Messpunkte(3).Groesse='Kraft';
    Messwerte.Messpunkte(3).Sensor='PCB 208 C02 SN16141';
    Messwerte.Messpunkte(3).EU='N';
    Messwerte.Messpunkte(3).Kalibrierwert=11.241;
    Messwerte.Messpunkte(3).Kalibrierwert_unit='mV/N';
    Messwerte.Messpunkte(3).Koord_x=0;
    Messwerte.Messpunkte(3).Koord_y=0;
    Messwerte.Messpunkte(3).Koord_z=0;
    
    
    switch V
        case 1
        Messwerte.Regelgroesse='Beschleunigung';
        Messwerte.Sollgroesse=b;
        case 2
        Messwerte.Regelgroesse='Weg';
        Messwerte.Sollgroesse=w;
        case 3
        Messwerte.Regelgroesse='Kraft';
        Messwerte.Sollgroesse=F;
    end
    
    Messwerte.Startfrequenz=f-df*(m-1);
    Messwerte.Stoppfrequenz=fmax;
    Messwerte.Frequenzintervall=df;
    
    Felder{1}='Frequenz';
    Felder{2}='Beschleunigung';
    Felder{3}='Kraft';
    Felder{4}='Weg';
    

   
    
    for zeil = 1:length(Ergebnis(:,1));
    for spalt = 1:4;
       Messwerte.Regelergebnis(zeil).(Felder{spalt})=Ergebnis(zeil,spalt);              
    end
    end
    
    
    
    Messwerte.Gesamtmesswerte=GE;


end

